Subject: ActionController ErrorAction forgets SubpackageKey
Description

The method errorAction of TYPO3\FLOW3\MVC\Controller\ActionController forwards like this:

$this->forward($referringRequest->getControllerActionName(), $referringRequest->getControllerName(),
$referringRequest->getControllerPackageKey(), $referringRequest->getArguments());

better would be something like this:

$controllerPackageKey = $referringRequest->getControllerPackageKey();
if ($referringRequest->getControllerSubPackageKey() !== NULL) {
    $controllerPackageKey .= '\\' . $referringRequest->getControllerSubpackageKey();
}

$this->forward($referringRequest->getControllerActionName(), $referringRequest->getControllerName(),
$controllerPackageKey, $referringRequest->getArguments());

Associated revisions
Revision 2d82dad1 - 2011-09-08 10:26 - Sebastian Kurfuerst

[BUGFIX] (MVC): ActionController ErrorAction forgets SubpackageKey

In case a validation error happened, a forward() is done to the referring
action, which then re-displays the form.

However, when the referring action contains a subpackage key, this redirection
was broken.

Change-Id: Id4dfaea7d919ba2eb8d031be505d76815927999f
Resolves: #28487

History
#1 - 2011-08-04 08:53 - Sebastian Kurfuerst
- Target version set to 1.0 beta 2

#2 - 2011-08-29 21:32 - Karsten Dambekalns
- Category set to MVC
#3 - 2011-09-06 09:19 - Sebastian Kurfuerst
- Status changed from New to Accepted
- Assigned To set to Sebastian Kurfuerst

I'm working on this now.

#4 - 2011-09-06 09:21 - Mr. Hudson
- Status changed from Accepted to Under Review

Patch set 1 of change Id4dfaea7d919ba2eb8d031be505d76815927999f has been pushed to the review server.
It is available at http://review.typo3.org/4783

#5 - 2011-09-08 10:26 - Mr. Hudson

Patch set 2 of change Id4dfaea7d919ba2eb8d031be505d76815927999f has been pushed to the review server.
It is available at http://review.typo3.org/4783

#6 - 2011-09-08 10:35 - Sebastian Kurfuerst
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:2d82dad18baef6741acb0d020b81b46059e18271.
